Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

<ProgId("VBNETCF.MSE"), ClassInterface(ClassInterfaceType.AutoDispatch)> _
Public Class MSE

    Public Shared DataHelper As New GXPT4CFHelper.DataSet

    Public Function Calculate(ByRef gxptTarget As Object, ByRef gxptOutput As Object, ByRef gxptParams As Object, ByRef gxptModelInfo As Object) As Object 'Implements ICustomFitness.Calculate


        'This method must be called always. Internally it uses caching to minimize
        'any performance penalty. Replace the file below with a COPY of the run you are using.
        'This copy run must have the exact same Training and Testing sets and the same number
        'of samples as the run that is being evaluated.
        DataHelper.Initialise("c:\Documents and Settings\ze\My Documents\Acottest.gep", gxptTarget, gxptOutput, gxptParams, gxptModelInfo)

        'These are examples of the interface available to you

        'This is how you access the values in the current set
        Debug.Print(DataHelper.GetDoubleValue(0, 0, GXPT4CFHelper.DataSetEnum.dsTrainingSet))

        'This property returns the set that is now being passed to this
        'fitness function. It relies on both sets having a different number of
        'samples so it does not work when both the Training and Testing set
        'have the same number of samples.
        Debug.Print(DataHelper.CurrentSet)

        'Returns the number of variables plus the dependent variable
        Debug.Print(DataHelper.Columns)

        'Returns the number of samples in use in the Training set
        Debug.Print(DataHelper.TrainingSamples)

        'Returns the number of samples in use in the Testing set
        Debug.Print(DataHelper.TestingSamples)

        'Returns the last error after a DataHelper call. You should
        'check if DataHelper.ErrorNumber is not zero to ensure that
        'it is returning a valida value.
        If DataHelper.ErrorNumber > 0 Then
            Debug.Print(DataHelper.ErrorDescription)
        End If

        '-------------------------------------------------------------------
        'Implementation of the MSE fitness function
        Dim nSamples As Integer
        nSamples = gxptParams(0)
        Dim modelMinusTargetSquared As Double
        Dim fitness As Double
        Dim temp1 As Double
        Dim i As Integer

        For i = 0 To nSamples - 1

            temp1 = 0
            temp1 = gxptOutput(i) - gxptTarget(i)
            temp1 *= temp1
            modelMinusTargetSquared = modelMinusTargetSquared + temp1
        Next

        fitness = modelMinusTargetSquared / nSamples

        If fitness <= 0.000000001 Then
            fitness = 0.0#
        End If

        Return (1 / (1 + fitness)) * 1000

    End Function
End Class